import 'package:flutter/material.dart';
import 'package:login/login.dart';
import 'package:supper_app/supper_app.dart';
export './login_screen.dart';

class LoginRoute implements ModuleRoute {
  @override
  String modulePath() {
    return "login";
  }

  @override
  Route<dynamic> routes(RouteSettings settings) {
    if ((settings.name ?? "").contains('/login')) {
      final args =
          Modules.arguments(settings, "/login", (x) => LoginProps.fromMap(x));
      return MaterialPageRoute(
          builder: (_) => LoginScreen(
                props: args as LoginProps,
              ));
    }
    return DefaultRoute.notFound();
  }
}

class LoginRouteGenerator extends MiniAppRouteGenerator {
  @override
  Route<dynamic> generateRoute(RouteSettings settings) {
    return LoginRoute().routes(settings);
  }
}
