import 'package:flutter/material.dart';
import 'modules.dart';

abstract class ModuleRoute {
  Route<dynamic> routes(RouteSettings settings);
  String modulePath();
}

class MainRouteGenerator {
  static Route<dynamic> routes(RouteSettings settings) {
    for (final module in Modules().getModules()) {
      if ((settings.name ?? "").contains(module.modulePath())) {
        return module.routes(settings);
      }
    }
    return DefaultRoute.notFound();
  }
}

class DefaultRoute {
  static Route<dynamic> notFound() => MaterialPageRoute(
      builder: (_) => const Scaffold(
            body: Center(
              child: Text("Page not found !"),
            ),
          ));

  static Widget splashScreen(Widget? screen) {
    if (screen != null) {
      return screen;
    } else {
      return const Scaffold(
        body: Center(
          child: Text("Hello"),
        ),
      );
    }
  }
}

abstract class MiniAppRouteGenerator {
  Route<dynamic> generateRoute(RouteSettings settings);
}
