library mini2;

import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:mini2/first_screen.dart';
import 'package:mini2/second_screen.dart';
import 'package:supper_app/supper_app.dart';
import 'package:login/login.dart';

class Mini2Route implements ModuleRoute {
  @override
  String modulePath() {
    return "haha";
  }

  @override
  Route<dynamic> routes(RouteSettings settings) {
    if ((settings.name ?? "").contains('/FirstScreen')) {
      return MaterialPageRoute(builder: (_) => FirstScreen());
    }
    if ((settings.name ?? "").contains('/SecondScreen')) {
      final args = Modules.arguments(
          settings, "/SecondScreen/", (x) => SecondScreenProp.fromMap(x));
      return authenticateGuardRoute(
          MaterialPageRoute(
              builder: (_) => SecondScreen(props: args as SecondScreenProp)),
          settings);
    }
    return DefaultRoute.notFound();
  }
}

class Mini2RouteGenerator {
  static Route<dynamic> generateRoute(RouteSettings settings) {
    return Mini2Route().routes(settings);
  }
}
